[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.82

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.50      afresh1    18: set -o errexit -o pipefail -o nounset
1.77      afresh1    19: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    20:
                     21: CFILE=SHA256.sig
                     22: DESTDIR=${DESTDIR:-}
                     23: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     24:
                     25: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     26: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     27:
                     28: HTTP_FWDIR="$VNAME"
1.52      afresh1    29: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     30:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    31: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    32:
1.50      afresh1    33: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     34: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    35:
1.69      afresh1    36: LOCALSRC=
                     37:
1.8       afresh1    38: tmpdir() {
                     39:        local _i=1 _dir
                     40:
1.50      afresh1    41:        # If we're not in the installer,
1.79      afresh1    42:        # we have mktemp and a more hostile environment.
1.50      afresh1    43:        if [ -x /usr/bin/mktemp ]; then
                     44:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    45:        else
1.50      afresh1    46:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    47:                    ((++_i < 10000)) || return 1
                     48:                done
                     49:        fi
1.50      afresh1    50:
1.8       afresh1    51:        echo "$_dir"
                     52: }
1.6       afresh1    53:
1.50      afresh1    54: fetch() {
1.69      afresh1    55:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit
1.6       afresh1    56:
1.79      afresh1    57:        # If we're not in the installer,
                     58:        # we have su(1) and doas(1) is unlikely to be configured.
1.53      afresh1    59:        if [ -x /usr/bin/su ]; then
1.50      afresh1    60:                /usr/bin/su -s /bin/ksh "$_user" -c \
1.69      afresh1    61:                    "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
1.50      afresh1    62:                _exit="$?"
1.42      afresh1    63:        else
1.50      afresh1    64:                /usr/bin/doas -u "$_user" \
1.69      afresh1    65:                    /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
1.50      afresh1    66:                _exit="$?"
1.42      afresh1    67:        fi
1.6       afresh1    68:
1.50      afresh1    69:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1    70:                rm -f "$_dst"
                     71:                echo "Cannot fetch $_src" >&2
1.50      afresh1    72:                return 1
                     73:        fi
1.6       afresh1    74: }
                     75:
1.50      afresh1    76: verify() {
                     77:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1    78:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                     79:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1    80:                return 1
                     81:        fi
1.6       afresh1    82: }
                     83:
1.50      afresh1    84: devices_needing_firmware() {
                     85:        local _d _m _grep _dmesgtail _last=''
1.1       afresh1    86:
1.50      afresh1    87:        # When we're not in the installer, the dmesg.boot can
                     88:        # contain multiple boots, so only look in the last one
                     89:        _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )
                     90:
                     91:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                     92:            while read -r _d _m; do
                     93:                _grep="grep"
                     94:                [ "$_last" = "$_d" ] && continue
                     95:                [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "
                     96:                [ "$_m" = "${_m#^}" ] && _grep="fgrep"
                     97:
                     98:                echo "$_dmesgtail" | $_grep -q "$_m" || continue
                     99:                echo "$_d"
                    100:                _last="$_d"
                    101:        done
                    102: }
1.14      afresh1   103:
1.50      afresh1   104: firmware_filename() {
1.56      afresh1   105:        local _f
                    106:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    107:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    108:        echo "$_f"
1.50      afresh1   109: }
1.7       afresh1   110:
1.57      afresh1   111: firmware_devicename() {
                    112:        local _d="${1##*/}"
                    113:        _d="${_d%-firmware-*}"
                    114:        echo "$_d"
                    115: }
                    116:
1.50      afresh1   117: installed_firmware() {
                    118:        for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                    119:                [ -e "$fw" ] || continue
                    120:                echo "${fw##*/}"
                    121:        done
                    122: }
1.1       afresh1   123:
1.50      afresh1   124: add_firmware () {
1.74      afresh1   125:        local _f="${1##*/}"
                    126:        local _pkgdir="${DESTDIR}/var/db/pkg/${_f%.tgz}"
1.50      afresh1   127:        ftp -D "Install" -Vmo- "file:${1}" |
1.73      afresh1   128:                tar -s ",^\+,${_pkgdir}/+," \
1.69      afresh1   129:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    130:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   131:
1.50      afresh1   132:        # TODO: Should we mark these so real fw_update can -Drepair?
1.73      afresh1   133:        ed -s "${_pkgdir}/+CONTENTS" <<EOL
1.50      afresh1   134: /^@comment pkgpath/ -1a
                    135: @option manual-installation
                    136: @option firmware
                    137: @comment install-script
                    138: .
                    139: w
                    140: EOL
                    141: }
1.22      afresh1   142:
1.50      afresh1   143: delete_firmware() {
1.51      afresh1   144:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   145:
1.50      afresh1   146:        # TODO: Check hash for files before deleting
                    147:        echo "Uninstalling $_pkg"
1.51      afresh1   148:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   149:
1.51      afresh1   150:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   151:
                    152:        while read -r c g; do
                    153:                case $c in
1.51      afresh1   154:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   155:                  ;;
                    156:                @*) continue
                    157:                  ;;
1.52      afresh1   158:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   159:                  ;;
                    160:                esac
                    161:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    162:
                    163:        # We specifically rm -f here because not removing files/dirs
                    164:        # is probably not worth failing over.
                    165:        for _r in "${_remove[@]}" ; do
                    166:                if [ -d "$_r" ]; then
                    167:                        # Try hard not to actually remove recursively
                    168:                        # without rmdir on the install media.
                    169:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                    170:                else
                    171:                        rm -f "$_r"
1.22      afresh1   172:                fi
                    173:        done
1.50      afresh1   174: }
1.1       afresh1   175:
1.59      afresh1   176: usage() {
1.81      afresh1   177:        echo "usage: fw_install [-DL] [driver | file [...]]"
1.59      afresh1   178:        exit 2
                    179: }
                    180:
1.68      afresh1   181: INSTALL=true
                    182: DOWNLOAD=true
                    183:
1.82    ! afresh1   184: while getopts DL name
1.59      afresh1   185: do
                    186:        case "$name" in
1.68      afresh1   187:        # "download only" means local dir and don't install
1.81      afresh1   188:        D) LOCALSRC=. INSTALL=false ;;
1.69      afresh1   189:        L) LOCALSRC=. ;;
1.59      afresh1   190:        ?) usage 2 ;;
                    191:        esac
                    192: done
                    193: shift $((OPTIND - 1))
                    194:
1.68      afresh1   195: # If we're installing from a local dir
                    196: # we don't want to download anything
1.69      afresh1   197: [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
                    198: [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
1.64      afresh1   199:
1.78      afresh1   200: CFILE="$LOCALSRC/$CFILE"
                    201:
1.58      afresh1   202: set -A devices -- "$@"
                    203:
                    204: [ "${devices[*]:-}" ] ||
                    205:     set -A devices -- $( devices_needing_firmware )
1.1       afresh1   206:
1.65      afresh1   207: if [ ! "${devices[*]:-}" ]; then
1.50      afresh1   208:        echo "No devices found which need firmware files to be downloaded."
                    209:        exit
                    210: fi
                    211:
1.71      afresh1   212: if "$DOWNLOAD"; then
1.64      afresh1   213:        fetch "$CFILE"
                    214:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    215:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
                    216: fi
1.50      afresh1   217:
1.70      afresh1   218: for f in "${devices[@]}"; do
                    219:        d="$( firmware_devicename "$f" )"
                    220:
1.58      afresh1   221:        if [ "$f" = "$d" ]; then
                    222:                f=$( firmware_filename "$d" || true )
                    223:                [ "$f" ] || continue
1.69      afresh1   224:                f="$LOCALSRC/$f"
1.76      afresh1   225:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   226:                echo "Cannot download local file $f" >&2
                    227:                exit 2
1.58      afresh1   228:        fi
                    229:
1.50      afresh1   230:        set -A installed -- $( installed_firmware "$d" )
                    231:
1.68      afresh1   232:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   233:                for i in "${installed[@]}"; do
1.58      afresh1   234:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.50      afresh1   235:                                echo "$i already installed"
1.11      afresh1   236:                                continue 2
1.1       afresh1   237:                        fi
                    238:                done
1.50      afresh1   239:        fi
1.1       afresh1   240:
1.72      afresh1   241:        if [ -e "$f" ]; then
                    242:                if "$DOWNLOAD"; then
                    243:                        echo "Verify existing ${f##*/}"
                    244:                        verify "$f" || continue
                    245:                # else assume it was verified when downloaded
                    246:                fi
1.75      afresh1   247:        elif "$DOWNLOAD"; then
                    248:                fetch  "$f" || continue
                    249:                verify "$f" || continue
                    250:        elif "$INSTALL"; then
1.72      afresh1   251:                echo "Cannot install ${f##*/}, not found" >&2
                    252:                continue
1.58      afresh1   253:        fi
1.60      afresh1   254:
1.68      afresh1   255:        "$INSTALL" || continue
1.11      afresh1   256:
1.65      afresh1   257:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   258:                for i in "${installed[@]}"; do
                    259:                        delete_firmware "$i"
                    260:                done
                    261:        fi
1.11      afresh1   262:
1.50      afresh1   263:        add_firmware "$f"
                    264: done
1.1       afresh1   265:

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>